<?php

#
# $Id: currencies.php,v 4.2.1.0 22/06/2009
#

require "./auth.php";
require $xcart_dir."/include/security.php";
$location[] = array(func_get_langvar_by_name("lbl_currencies_management"), "");

$zones[] = array("zone" => "ACT", "title" => func_get_langvar_by_name("lbl_active"));
$zones[] = array("zone" => "ALL", "title" => func_get_langvar_by_name("lbl_all_regions"));
$zones[] = array("zone" => "NA", "title" => func_get_langvar_by_name("lbl_na"));
$zones[] = array("zone" => "EU", "title" => func_get_langvar_by_name("lbl_eu"));
$zones[] = array("zone" => "AU", "title" => func_get_langvar_by_name("lbl_au"));
$zones[] = array("zone" => "LA", "title" => func_get_langvar_by_name("lbl_la"));
$zones[] = array("zone" => "SU", "title" => func_get_langvar_by_name("lbl_su"));
$zones[] = array("zone" => "AS", "title" => func_get_langvar_by_name("lbl_asia"));
$zones[] = array("zone" => "AF", "title" => func_get_langvar_by_name("lbl_af"));
$zones[] = array("zone" => "AN", "title" => func_get_langvar_by_name("lbl_an"));

$zone_is_valid = false;
if (!empty($zone)) {
	foreach ($zones as $k=>$v) {
		if ($zone == $v["zone"]) {
			$zone_is_valid = true;
			break;
		}
	}
	if ($zone == "ALL")
		$zone = "";
}
else {
	if ($REQUEST_METHOD != "POST")
		$zone = "ACT";
	else
		$zone = "ALL";
}

#
# currencies per page
#
$objects_per_page = 40;

if ($REQUEST_METHOD == "POST") {

	if (!empty($mode)) {
		if ($mode == "deactivate_all") {
			db_query("UPDATE $sql_tbl[currency_rate] SET active='N'");
			db_query("UPDATE $sql_tbl[currency_rate] SET active = 'Y' WHERE code = (SELECT value FROM $sql_tbl[config] WHERE name = 'currency_symbol') OR code = (SELECT $sql_tbl[currencies].code FROM $sql_tbl[currencies] INNER JOIN $sql_tbl[config] ON $sql_tbl[currencies].symbol = $sql_tbl[config].value AND $sql_tbl[config].name = 'currency_symbol')");
			$top_message["content"] = func_get_langvar_by_name("msg_adm_currencies_disabled");
		}
		if ($mode == "activate_all") {
			db_query("UPDATE $sql_tbl[currency_rate] SET active='Y'");
			$top_message["content"] = func_get_langvar_by_name("msg_adm_currencies_enabled");
		}
		if ($mode == "auto_update") {
			x_load('files', 'backoffice');
			# Import rates form a web site - default "http://rss.timegenie.com/forex.txt"
			$import_file = $config['Multi_Currency']['currency_import_file'];
			# Set delimiter type - default "|"
			$delimiter = $config['Multi_Currency']['currency_delimiter'];
			# Set all rates to null
			db_query ("UPDATE $sql_tbl[currency_rate] SET auto_rate=NULL");
			# Download csv file
			if ($fp = func_fopen($import_file, "r", true)) {
				while ($columns = fgetcsv ($fp, 65536, $delimiter)) {
					$columns = func_addslashes($columns);
					db_query ("UPDATE $sql_tbl[currency_rate] SET auto_rate='$columns[2]' WHERE code='$columns[0]'");
				}
				fclose($fp);
				$def_currency = $config['Multi_Currency']['default_currency'];
				$def_currency_rate = func_query("SELECT rate, auto_rate FROM $sql_tbl[currency_rate] WHERE code='$def_currency'");
				if (is_null($def_currency_rate[0]["auto_rate"])) {
					$def_currency = "EUR";
					$def_currency_rate = func_query("SELECT rate, auto_rate FROM $sql_tbl[currency_rate] WHERE code='$def_currency'");
				}
				db_query ("UPDATE $sql_tbl[currency_rate] SET rate = ".$def_currency_rate[0]["rate"]."*".$def_currency_rate[0]["auto_rate"]."/auto_rate WHERE auto_rate IS NOT NULL");
				$top_message["content"] = func_get_langvar_by_name("msg_adm_currencies_upd");
			} else {
				$top_message["content"] = func_get_langvar_by_name("msg_err_file_operation");
				$top_message["type"] = "W";
			}
		}
		func_header_location("currencies.php?zone=$zone&page=$page");
	}

	if (is_array($posted_data)) {
		foreach ($posted_data as $k=>$v) {
			$v["active"] = (isset($v["active"]) ? "Y" : "N" );
			$v["rate"] = str_replace(',', '.', $v["rate"]);
			db_query("UPDATE $sql_tbl[currencies] SET name='$v[currency]', symbol='$v[symbol]' WHERE code='$k'");
			db_query("UPDATE $sql_tbl[currency_rate] SET rate='$v[rate]', order_by='$v[orderby]', active='$v[active]', auto_rate = NULL WHERE code='$k'");
		}
		$top_message["content"] = func_get_langvar_by_name("msg_adm_currencies_upd");
		func_data_cache_get("languages", array($shop_language), true);
	}
	
	func_header_location("currencies.php?zone=$zone&page=$page");
}

$condition = "";
if (!empty($zone)) {
	if ($zone == "SU") {
		$condition = " WHERE $sql_tbl[countries].code IN ('AM','AZ','BY','EE','GE','KZ','KG','LV','LT','MD','RU','TJ','TM','UA','UZ')";
	} else {
		if ($zone == "ACT") {
			$condition = " WHERE $sql_tbl[currency_rate].active = 'Y'";
		} else {
			$condition = " WHERE $sql_tbl[countries].region='$zone'";
		}
	}
}

$total_items_in_search = func_query_first_cell("SELECT COUNT(DISTINCT ($sql_tbl[currencies].code)) FROM $sql_tbl[currency_rate] INNER JOIN $sql_tbl[currencies] ON $sql_tbl[currency_rate].code = $sql_tbl[currencies].code INNER JOIN $sql_tbl[country_currencies] ON $sql_tbl[currencies].code = $sql_tbl[country_currencies].code INNER JOIN $sql_tbl[countries] ON $sql_tbl[country_currencies].country_code = $sql_tbl[countries].code $condition");

#
# Navigation code
#
$total_nav_pages = ceil($total_items_in_search/$objects_per_page);

require $xcart_dir."/include/navigation.php";

$smarty->assign("navigation_script","currencies.php?zone=".(empty($zone)?"ALL":$zone));

if ($zone == "ACT") {
	$orderby = " ORDER BY $sql_tbl[currency_rate].order_by";
} else {
	$orderby = " ORDER BY $sql_tbl[currencies].code";
}

$currencies = func_query("SELECT $sql_tbl[currency_rate].*, $sql_tbl[currencies].*, $sql_tbl[countries].code AS country_code FROM $sql_tbl[currency_rate] INNER JOIN $sql_tbl[currencies] ON $sql_tbl[currency_rate].code = $sql_tbl[currencies].code INNER JOIN $sql_tbl[country_currencies] ON $sql_tbl[currencies].code = $sql_tbl[country_currencies].code INNER JOIN $sql_tbl[countries] ON $sql_tbl[country_currencies].country_code = $sql_tbl[countries].code $condition GROUP BY $sql_tbl[currencies].code $orderby LIMIT $first_page, $objects_per_page");

$smarty->assign("currencies", $currencies);
$smarty->assign("zones", $zones);
$smarty->assign("zone", $zone);

$smarty->assign("main","currencies_edit");

# Assign the current location line
$smarty->assign("location", $location);

@include $xcart_dir."/modules/gold_display.php";
func_display("admin/home.tpl",$smarty);
?>
